/*

    File: LODModel.h

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#if !defined(ASTEROIDS3D_V2_LODMODEL_H)
#define ASTEROIDS3D_V2_LODMODEL_H

#include "model.h"
#include "../m_math3d/vector.h"

#define LODMODEL_MAX_DEPTH	16

//TODO: KICK CHAIN'S ASS.  AND THEN GET RID OF IT
#include "../m_foundation/chain.h"

class LODModel : public Chain {
public:
	LODModel()	{Reset();}
	~LODModel()	{Unload();}

	bool		Load(char *filename);
	void		Unload(void);

	Model		*GetModelByWidth(scalar_t width);
	Model		*GetModelByLevel(int level);

	void		Display(scalar_t width);
	void		Display(int level);
	void		DisplayInterpolate(scalar_t width);

	int			GetCount(void)	{ return count;}

	void		Compile(void);

	friend		LODModel *GetLODModel(LinkedList *p, char *title);
	friend		void LODModel_Calculate(LODModel *m, float width);
	friend		void LODModel_Display(void);

private:
	void		Reset(void);

	bool		LoadLOD(Model *m);

	Model		*model[LODMODEL_MAX_DEPTH];
	scalar_t	invWidth[LODMODEL_MAX_DEPTH];
	int			count;
};

#endif