/*

    File: Lighting.h

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#if !defined(LIGHTING_H)
#define LIGHTING_H

typedef struct lightinfo_s {
	float			position[4];
	float			diffuse[4];
	float			attenuation[3];	//color *= 1.0/(attn[0] + del*attn[1] + del*del*attn[2])
	scalar_t		distance;		//by default this is -1, indicating the light has inf dist
} lightinfo_t;

bool Init_Lighting(void);
void Shutdown_Lighting(void);

void Reset_Lighting(void);
void Update_Lighting(void);

//created lights are reset every frame

//creates a light and returns a struct for modifying
lightinfo_t *Create_Light(void);
//after modifying the struct, call Register_Light to add the light to the bsp tree
void Register_Light(lightinfo_t *light);

//commonly cited constant
#define light_default_linear_attenuation		0.0001f
#define	light_default_quadratic_attenuation		0.0000001f

#endif