/*

    File: Model.h

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#ifndef ASTERIODS3D_V2_MODEL_H
#define ASTERIODS3D_V2_MODEL_H

#include "../m_math3d/geometry.h"
#include "../m_foundation/chain.h"
#include "../m_foundation/types.h"

class Model : public Chain {
public:
	Model()		{Reset();}
	~Model()	{Unload();}
private:
	void Reset(void);
public:

	bool Load(char *filename);
	void Unload(void);

	bool Copy(Model *src);

	void Display(void);

	void Compile(void);

	void CalcNormals(void);		//private
	void CalcRange(void);		//private

	bool		compiled;		//private
	unsigned int list_id;		//private

	char		title[64];

	int			triCount;
	int			*tri;		//3*triCount

	int			vtxCount;
	vector_t	*vtx;		//vtxCount
	float		*texCoord;	//2*vtxCount
	vector_t	*normal;	//vtxCount
	int			*collapse;	//vtxCount

	box_t		bbox;
	float		radius;	//stealing Quake1 ideas... maximum magnitude vertex distance - ONLY USED FOR DEBUG NORMAL DISPLAY!!!

	friend Model *GetModel(LinkedList *p, char *title);
};

#endif