/*

    File: Particle.h

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#ifndef PARTICLE_H
#define PARTICLE_H

#include "../m_math3d/vector.h"
#include "../m_foundation/types.h"
#include "../m_foundation/texture.h"

bool Init_ParticleSystem(int count);
void Shutdown_ParticleSystem(void);
void Update_ParticleSystem(void);
void Display_ParticleSystem(void);

void Particle_SetBlend(unsigned short src, unsigned short dest);
void Particle_SetTexture(Texture *t);
void Particle_Create(const vector_t *pos, const vector_t *vel, scalar_t size, int color, int life, bool fade);
int Particle_Counter(void);

#endif